library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity irqselreg is
   port (
	clk: in STD_LOGIC;
	ibus: in STD_LOGIC_VECTOR (15 downto 0);
	obus: out STD_LOGIC_VECTOR (15 downto 0);
	loadirqsel: in STD_LOGIC;
	readirqsel: in STD_LOGIC;
	irqselreg: out STD_LOGIC_VECTOR (3 downto 0);
	irqtsenablereg: out STD_LOGIC;
	irqmaskreg: out STD_LOGIC);
end irqselreg;

architecture behavioral of irqselreg is



signal loadirqsel1: STD_LOGIC;
signal loadirqsel2: STD_LOGIC;
signal irqsel: STD_LOGIC_VECTOR (3 downto 0);
signal irqtsenable: STD_LOGIC;
signal irqmask: STD_LOGIC;

begin
	airqselreg: process(clk, 
	 					
							ibus,
							loadirqsel,loadirqsel1,loadirqsel2,
							readirqsel,
							irqsel,
							irqtsenable,
							irqmask)
							
	begin
		if clk'event and clk = '1' then
			loadirqsel1 <= loadirqsel;
			loadirqsel2 <= loadirqsel1;
			if (loadirqsel1 = '0') and (loadirqsel2 = '1') then -- trailing edge of command
 		   	irqsel <=  ibus(3 downto 0);
				irqtsenable <= ibus(4);
				irqmask <= ibus(5);
			end if;	
		end if;
		if readirqsel = '1' then
			obus(3 downto 0) <= irqsel;
			obus(4) <= irqtsenable;
			obus(5) <= irqmask;
			obus(15 downto 8) <= "ZZZZZZZZ";
		else
			obus <= "ZZZZZZZZZZZZZZZZ";
		end if;
	irqselreg <= irqsel;
	irqtsenablereg <= irqtsenable;
	irqmaskreg <= irqmask;
	end process;
end behavioral;

