library IEEE;
use IEEE.STD_LOGIC_1164.ALL;



entity CommandReg is
    Port ( 	
	 		clk: in STD_LOGIC;
			procibus: in STD_LOGIC_VECTOR (15 downto 0);
			procobus: out STD_LOGIC_VECTOR (15 downto 0);
			procreadcommand: in STD_LOGIC;
			procwritestatus: in STD_LOGIC;
			procreadstatus: in STD_LOGIC;
			hostibus: in STD_LOGIC_VECTOR (15 downto 0);
			hostobus: out STD_LOGIC_VECTOR (15 downto 0);
			hostreadcommand: in STD_LOGIC;
			hostwritecommand: in STD_LOGIC;
			clrbusyflag: in STD_LOGIC;
			busyflag: out STD_LOGIC
			);
end CommandReg;

architecture behavioral of CommandReg is

signal hostcommandreg: STD_LOGIC_VECTOR (15 downto 0);
signal procstatusreg: STD_LOGIC_VECTOR (15 downto 0);
signal hostwrcom1: STD_LOGIC;
signal hostwrcom2: STD_LOGIC;
signal busyf: STD_LOGIC;

begin	acommandreg: process
					(
						clk,
						hostcommandreg,
						procstatusreg,
						hostwrcom1,hostwrcom2,
						busyf,								
						procibus,
						procreadcommand,
						procwritestatus,
						procreadstatus,
						hostibus,
						hostwritecommand,
						hostreadcommand,
						clrbusyflag						
						)
							
	begin
		if clk'event and clk = '1' then
			-- proc write logic

			if procwritestatus = '1' then
				procstatusreg(15 downto 0)  <= procibus;
			end if;

			-- host write logic

			hostwrcom1 <= hostwritecommand;
			hostwrcom2 <= hostwrcom1;

			if (hostwrcom1 = '0') and (hostwrcom2 = '1') then 
 		  	 	busyf <=  '1';
				hostcommandreg <= hostibus;
			end if;

			if clrbusyflag = '1' then
 				busyf <= '0';
			end if;

		end if; 

		--		host read logic
			
		if	hostreadcommand = '1' then
			hostobus(14 downto 0) <= procstatusreg(14 downto 0);
			hostobus(15) <= busyf;
		else 
			hostobus <= "ZZZZZZZZZZZZZZZZ";
		end if;

		-- proc read logic
		procobus <= "ZZZZZZZZZZZZZZZZ";		
		if (procreadcommand or procreadstatus) = '1' then
			if procreadcommand = '1' and procreadstatus = '0' then
				procobus <= hostcommandreg;
			end if;
			if procreadstatus = '1' and procreadcommand = '0' then
				procobus <= procstatusreg;
			end if;
		else
			procobus <= "ZZZZZZZZZZZZZZZZ";
		end if;
		busyflag <= busyf;
	end process;

end behavioral;
