library IEEE;
use IEEE.STD_LOGIC_1164.ALL;



entity CommandReg is
    Port ( 	
	 		clk: in STD_LOGIC;
			procibus: in STD_LOGIC_VECTOR (7 downto 0);
			procobus: out STD_LOGIC_VECTOR (7 downto 0);
			procadd: in STD_LOGIC;
			procreadcommand: in STD_LOGIC;
			procwritecommand: in STD_LOGIC;
			hostibus: in STD_LOGIC_VECTOR (15 downto 0);
			hostobus: out STD_LOGIC_VECTOR (15 downto 0);
			hostreadcommand: in STD_LOGIC;
			hostwritecommand: in STD_LOGIC;
			clrbusyflag: in STD_LOGIC;
			busyflag: out STD_LOGIC
			);
end CommandReg;

architecture behavioral of CommandReg is

signal hostcommandreg: STD_LOGIC_VECTOR (15 downto 0);
signal procstatusreg: STD_LOGIC_VECTOR (15 downto 0);
signal hostwrcom1: STD_LOGIC;
signal hostwrcom2: STD_LOGIC;
signal busy: STD_LOGIC;

begin	acommandreg: process
					(
						clk,
						hostcommandreg,
						procstatusreg,
						hostwrcom1,hostwrcom2,
						busy,								
						procibus,
						procadd,
						procreadcommand,
						procwritecommand,					
						hostibus,
						hostwritecommand,
						hostreadcommand,
						clrbusyflag						
						)
							
	begin
		if clk'event and clk = '1' then
			-- proc write logic

			if procwritecommand = '1' then
				if procadd = '0' then
					procstatusreg(7 downto 0)  <= procibus;
				else
					procstatusreg(15 downto 8) <= procibus;					 
				end if;
			end if;

			-- host write logic

			hostwrcom1 <= hostwritecommand;
			hostwrcom2 <= hostwrcom1;

			if (hostwrcom1 = '0') and (hostwrcom2 = '1') then 
 		  	 	busy <=  '1';
				hostcommandreg <= hostibus;
			end if;

			if clrbusyflag = '1' then
 				busy <= '0';
			end if;

		end if; 

		--		host read logic
		
		hostobus <= "ZZZZZZZZZZZZZZZZ";
		if	hostreadcommand = '1' then
			hostobus(14 downto 0) <= procstatusreg(14 downto 0);
			hostobus(15) <= busy;
		end if;

		-- proc read logic
		
		procobus <= "ZZZZZZZZ";
		if procreadcommand = '1' then
			if procadd = '0' then
				procobus <= hostcommandreg(7 downto 0);
			end if;	
			if procadd = '1' then
				procobus <= hostcommandreg(15 downto 8);
			end if;
		end if;
	
		busyflag <= busy;
	end process;

end behavioral;
