library IEEE;
use IEEE.STD_LOGIC_1164.ALL;



entity DataReg is
    Port ( 	
	 		clk: in STD_LOGIC;
			procibus: in STD_LOGIC_VECTOR (7 downto 0);
			procobus: out STD_LOGIC_VECTOR (7 downto 0);
			procadd: in STD_LOGIC_VECTOR (1 downto 0);
			procreaddata: in STD_LOGIC;						
			procwritedata: in STD_LOGIC;
			hostibus: in STD_LOGIC_VECTOR (15 downto 0);
			hostobus: out STD_LOGIC_VECTOR (15 downto 0);
			hostreadadd: in STD_LOGIC;
			hostwriteadd: in STD_LOGIC;
			hostreaddata: in STD_LOGIC;
			hostwritedata: in STD_LOGIC;
			hostdataclear: in STD_LOGIC
			);
end DataReg;

architecture behavioral of DataReg is


signal hostdatareg: STD_LOGIC_VECTOR (31 downto 0);
signal procdatareg: STD_LOGIC_VECTOR (31 downto 0);
signal hostwrdat1: STD_LOGIC;
signal hostwrdat2: STD_LOGIC;


begin	adatareg: process
					(
						clk,
						hostdatareg,
						procdatareg,
						hostwrdat1,hostwrdat2,				
						procibus,
						procadd,
						procwritedata,
						procreaddata,					
						hostibus,
						hostreadadd,
						hostwriteadd,
						hostwritedata,
						hostreaddata,
						hostdataclear
						)
							
	begin
		if clk'event and clk = '1' then
			-- proc write logic
  
			if procwritedata = '1' then
				case procadd is
					when "00" => procdatareg( 7 downto 0) <= procibus;
					when "01" => procdatareg(15 downto 8) <= procibus;					
					when "10" => procdatareg(23 downto 16) <= procibus;				
					when "11" => procdatareg(31 downto 24) <= procibus;
					when others => 
				end case;
			end if;

			-- host write logic
			hostwrdat1 <= hostwritedata;
			hostwrdat2 <= hostwrdat1;			


			if (hostwrdat1 = '0') and (hostwrdat2 = '1') then
 				if hostwriteadd = '0' then
					hostdatareg(15 downto 0) <= hostibus;
				end if;
 				if hostwriteadd = '1' then
					hostdatareg(31 downto 16) <= hostibus;
				end if;
			end if;
			if hostdataclear = '1' then
				hostdatareg <= x"00000000";
			end if;
		end if; -- clk 

		--		host read logic

		if	hostreaddata = '1' then
			if hostreadadd = '0' then
				hostobus <= procdatareg(15 downto 0);
			end if;
			if hostreadadd = '1' then
				hostobus <= procdatareg(31 downto 16);			
			end if;
		else 
			hostobus <= "ZZZZZZZZZZZZZZZZ"; 
		end if;
		
		-- proc read logic
		
	
		if procreaddata = '1'then
			case procadd is
				when "00" => procobus <= hostdatareg( 7 downto 0);
				when "01" => procobus <= hostdatareg(15 downto 8);				
				when "10" => procobus <= hostdatareg(23 downto 16);
				when "11" => procobus <= hostdatareg(31 downto 24);
				when others =>
			end case;
		else
			procobus <= "ZZZZZZZZ";
		end if;

	end process;

end behavioral;
