library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity gindexreg is
   port (
	clk: in STD_LOGIC;
	ibus: in STD_LOGIC_VECTOR (2 downto 0 );
	obus: out STD_LOGIC_VECTOR (2 downto 0 );
	loadgindex: in STD_LOGIC;
	readgindex: in STD_LOGIC;
	cleargindex: in STD_LOGIC;
	gindexdata: out STD_LOGIC_VECTOR (2 downto 0)
	);
end gindexreg;

architecture behavioral of gindexreg is

signal gdata: STD_LOGIC_VECTOR (2 downto 0);


begin
	agindexreg: process(
							clk, 	 					
							ibus,
							loadgindex,readgindex,
							gdata
							)
							
	begin
		if clk'event and clk = '1' then
			if (loadgindex= '1') and (cleargindex = '0') then 
 		  	 	gdata <=  ibus;
			end if;
			if (cleargindex = '1') then 
				gdata <= "000";
			end if;
		end if;
		obus <= "ZZZ";
		if readgindex = '1' then
			obus <= gdata;
		end if;
		gindexdata <= gdata;
	end process;
end behavioral;
