library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity globalmodereg is
   port (
	clk: in STD_LOGIC;
	ibus: in STD_LOGIC_VECTOR (15 downto 0);
	obus: out STD_LOGIC_VECTOR (15 downto 0);
	reset: in STD_LOGIC;
	loadglobalmode: in STD_LOGIC;
	readglobalmode: in STD_LOGIC;
	ctrena: out STD_LOGIC;
	pwmena: out STD_LOGIC;
	clearpwmena: in STD_LOGIC;
	loi: out STD_LOGIC;
	som: out STD_LOGIC;
	miout: out STD_LOGIC;
	miin: in STD_LOGIC
	
	);
end globalmodereg;

architecture behavioral of globalmodereg is



signal loadglobalmode1: STD_LOGIC;
signal loadglobalmode2: STD_LOGIC;
signal ctrenareg: STD_LOGIC;
signal pwmenareg: STD_LOGIC;
signal loireg: STD_LOGIC;
signal somreg: STD_LOGIC;
signal mioutreg: STD_LOGIC;



begin
	aglobalmodereg: process(
							clk, 
							ibus,
							loadglobalmode,loadglobalmode1,loadglobalmode2,
							reset,
							readglobalmode,
 							ctrenareg,
							pwmenareg,
							clearpwmena,
							loireg,
							somreg,
							mioutreg,
							miin
							)
							
	begin
		if clk'event and clk = '1' then
			loadglobalmode1 <= loadglobalmode;
			loadglobalmode2 <= loadglobalmode1;

			if reset = '1' then 
 				ctrenareg <= '0';
				pwmenareg <= '0';
				loireg	 <= '0';
				somreg	 <= '0';
				mioutreg	 <= '1';			
			elsif (loadglobalmode1 = '0') and (loadglobalmode2 = '1') then -- trailing edge of command
 				ctrenareg <= ibus(0);
				pwmenareg <= ibus(1);
				loireg	 <= ibus(2);
				somreg	 <= ibus(3);
				mioutreg	 <= not ibus(4);
			end if;	

			if mioutreg = '1' then 
				mioutreg <= '0';
			end if;
		
		end if;
		
		if clearpwmena = '1' then 
			pwmenareg <= '0';
		end if;

		if readglobalmode = '1' then
			obus(0) <= ctrenareg;
			obus(1) <= pwmenareg;
			obus(2) <= loireg;
			obus(3) <= miin;
			obus(4) <= somreg;			
			obus(15 downto 5) <= "ZZZZZZZZZZZ";
		else
			obus <= "ZZZZZZZZZZZZZZZZ";
		end if;
		ctrena <= ctrenareg;
		pwmena <= pwmenareg;
		loi   <= loireg;
		miout <= mioutreg or reset;
		som	<= somreg;	
	end process;
end behavioral;

