program Load;

const
  BasePort = $220;
  RomAddress = BasePort + 8;
  RomData    = BasePort + $A;
  romsize = 1024;          {total size of ROM in words}
  jmp0 = $8100; {KCPSM processor jmp 0 instruction}

type
  FileName = string;
  Filevar = file of  byte;

var
  ROM : array [0 .. romsize] of word;
  LoadFileName : string;
  LoadFile : Filevar;

procedure GetParameter;
begin
    if length(ParamStr(1)) = 0 then
      begin
        writeln;
        write('Load file name? ');
        readln (LoadFileName);
      end
    else LoadFileName := ParamStr(1);
end;  { GetParameter }

function Open(var fp:Filevar; name: Filename): boolean;
begin
  Assign(fp,Name);
  {$I-}
  Reset(fp);
  {$I+}
  Open := (IOResult = 0);
end { Open };

procedure TestRam;
{do a simple address test of ROM -- for debugging interface}
var
index : word;
rbdata : word;
begin
  for index := 0 to romsize-1 do
  begin
    portw[ROMAddress] := index;
    portw[ROMData] := index;
  end;
  for index := 0 to romsize-1 do
  begin
    portw[ROMAddress] := index;
    rbdata := portw[ROMData];
    if rbdata <> index then
    begin
      writeln('expected ',index,' at address ',romaddress,' but read back ',rbdata);
    end;
  end;
end;

procedure FillBin;
var count  : integer;
    lobyte,hibyte : byte;
begin
  count := 0;
  if (not open(LoadFile,LoadFileName)) then
  begin
    writeln('Can''t open Load file: ',LoadFileName);
    halt(0);
  end;
  while not eof(LoadFile) do
      begin
      read(LoadFile,hibyte);
      read(LoadFile,lobyte);
      ROM[count] := lobyte + (hibyte*256);
      count := count +1;
     end; { while }
end { LoadIt };

procedure FillJmp0;
var
  index : integer;
begin
  for index := romsize-1 downto 0 do ROM[index] := jmp0;
end;

procedure loadram;
var
i : integer;
begin
  for i := romsize-1 downto 0 do
  begin
    portw[ROMAddress] := i;    { output address to address pointer }
    portw[ROMData] := ROM[i];  { output data to ROM at pointer location }
  end;
end;

begin
{  TestRam; }
  GetParameter;
  FillJmp0;
  loadram;
  FillBin;
  loadram;
  halt(0);
end.
