library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Lookuptable is
    Port ( clk : in std_logic;
           ibus : in std_logic_vector(15 downto 0);
           obus : out std_logic_vector(15 downto 0);
           selradd : in std_logic;
           selwadd : in std_logic;
		     readsel : in std_logic;
		     writesel : in std_logic);
end LookupTable;

architecture Behavioral of LookupTable is

  component tableram
	port (
		addr: IN std_logic_VECTOR(8 downto 0);
		clk: IN std_logic;
		din: IN std_logic_VECTOR(7 downto 0);
		dout: OUT std_logic_VECTOR(7 downto 0);
		we: IN std_logic);    
  end component tableram;

	
	signal add: std_logic_vector(9 downto 0);
	signal data: std_logic_vector(7 downto 0);
	signal write: std_logic;
begin

	ltableram: tableram  port map
	(
	addr => add(8 downto 0),
	clk =>  clk,
 	din =>  ibus(7 downto 0),
 	dout => data,
	we =>   write

	);	

	alookuptable: process (clk,readsel,writesel,selradd,selwadd,add,data)
	begin
		if clk'event and clk = '1' then		
			if writesel = '1' and selwadd = '0' then 
				add <= ibus(9 downto 0);
			end if;		
		end if; -- clk		

		if writesel = '1' and selwadd = '1' then
			write <= '1';
		else
			write <= '0';
		end if;				

		if	readsel = '1' then
			if selradd = '0' then
				obus(9 downto 0) <= add;
				obus(15 downto 10) <= "000000";
			else
				obus(7 downto 0) <= data;
				obus(15 downto 8) <= "00000000";
			end if;
		else 
			obus <= "ZZZZZZZZZZZZZZZZ"; 
		end if;

	end process;
end Behavioral;
