;MOTOR.ASM
;set go to start, done 
;pwm dead zone register
;BUGS


.include "kcpsm.mac"
.MSFIRST
;four rom processor

naxis	equ	4		;four axis

inittask	equ	0	;rom page
pidtask		equ	1
profiletask	equ	2
hosttask	equ	3
;************************* SYSTEM CONSTANTS *********************************
nroms		equ	4		;number of roms
clock		equ	50000000
ips		equ	clock/2		;instructions per second
prescale	equ	2048
intrate		equ	clock/prescale

;default parameters for 50mhz 
divrate		equ	8	;3051Hz	;intrate
idiv		equ	500	;2byte
ddiv		equ	4;200	;bug if 5 or more

;************************* QUAD COUNTER CONSTANTS ***************************
;cntcntl register

quada		equ	1
quadb		equ	2
index		equ	4	;true to clear counter
indexpol	equ	8
clronindex	equ	16
cntena		equ	32	;true to enable counter
quadfilter	equ	64	;true for filter
updwnmode	equ	128	;true for updown mode

;************************* RAM ***********************************************
;global ram non indexed
ramstart	equ	64
LASTRAM		equ	ramstart

	CHECKRAM

;128 indexed registers 
indexramstart	equ	128

;parameters
desposq		equ	(0 * q) + indexramstart
kpd		equ	(1 * q) + indexramstart
kid		equ	(2 * q) + indexramstart;all parameters are 32bit
kdd		equ	(3 * q) + indexramstart
hostmaxvelq	equ	(4 * q) + indexramstart
hostaccelq	equ	(5 * q) + indexramstart
mirrorencq	equ	(6 * q) + indexramstart
pidonq		equ	(7 * q) + indexramstart;true for pidon
exerrorq	equ	(8 * q) + indexramstart;excessive position error limit
exerrorfq	equ	(9 * q) + indexramstart;excessive position flag
hostledq	equ	(10 * q) + indexramstart;0:ledaxis 1:ledpointer
hostidivq	equ	(11 * q) + indexramstart;constant
hostddivq	equ	(12 * q) + indexramstart;constant
goq		equ	(13 * q) + indexramstart;set non zero to go

;internal use only
lastposq	equ	(14 * q) + indexramstart
debugq		equ	(15 * q) + indexramstart; for testing
ierrorq		equ	(16 * q) + indexramstart;i error
derrorq		equ	(17 * q) + indexramstart;d error
integralq	equ	(18 * q) + indexramstart
maxposerrq	equ	(19 * q) + indexramstart;l
idivq		equ	(20 * q) + indexramstart;constant
ddivq		equ	(21 * q) + indexramstart;constant
free22q		equ	(22 * q) + indexramstart;if desposq <> olddesposq then move
halfdistq	equ	(23 * q) + indexramstart
accelq		equ	(24 * q) + indexramstart
smaxvelq	equ	(25 * q) + indexramstart
deltaq		equ	(26 * q) + indexramstart
velocityq	equ	(27 * q) + indexramstart
moveq		equ	(28 * q) + indexramstart ;true if moving
curposx		equ	(29 * q) + 2 + indexramstart;48 bit position
;curposx	equ	(30 * q) + indexramstart;48 bit position
fixupq		equ	(31 * q) + indexramstart

LASTINDEXRAM	equ	fixupq + q

;	CHECKINDEXRAM
;************************* PORTS **********************************************
;read write
cntcntl		equ	6
statusreg	equ	8
axisindex	equ	9	;3 bits
rompages	equ	10
hcommd		equ	16	;two wasted bytes for simplicity
hdataq		equ	20

;input only
encposq		equ	0	;read position write to latch
in		equ	12

;outputs only
pwm		equ	0
dir		equ	4
cntl		equ	5	;latched by sample divider
samplediv	equ	7
ena		equ	13
out		equ	11
clrbusy		equ	24	;clear host busy flag
ledport		equ	63
;***************************** REGISTERS *************************************
raq   		equ     0 
rbq		equ	4
rcq		equ	8
rcounts		equ	12
tempt		equ	13
lastreg		equ	tempt + t

rax		equ	0		;raq,+ half of rbq
rbx		equ	6		;half of rbq + rcq

	CHECKREGS

;************************ MACROS ********************************************
.macro	nexttask	task
	loads	task,raq
	jmpa	1	;skip clr instruction
.endm

.macro	display0	r
	ife0	rcounts	
		display	r
 	endif
.endm

.macro	display1	r
	decs	rcounts
	ifz	
		display	r
 	endif
	incs	rcounts
.endm

.macro	iterate	counter,count
	UNIQUE	; The 'loop' label
	DUP
	loads	count-1,counter
LABEL
.endm

.macro	nextiterate	counter
	decs	counter
	jmpnc	LABEL	;back to for
.endm

;************************ TASK SWITCH ***************************************
;nexttask is in each task file

	org	romsize*0
.include	"tasksw.asm"	;same for all roms
.include	"init.asm"
	CHECKEOM
	
	org	romsize*1
.include	"tasksw.asm"	;same for all roms
.include	"pid.asm"
	CHECKEOM

	org	romsize*2
.include	"tasksw.asm"	;same for all roms
.include	"profile.asm"
	CHECKEOM

	org	romsize*3
.include	"tasksw.asm"	;same for all roms
.include	"host.asm"
	CHECKEOM

;************************ REVSIONS ********************************************
;revision       	equ     0


	.END

;renamed curposq to encposq
;added currposq 