library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity pwmgen is
	port (
	clk: in STD_LOGIC;
	refcount: in STD_LOGIC_VECTOR (7 downto 0);
	ibus: in STD_LOGIC_VECTOR (15 downto 0);
	loadpwmval: in STD_LOGIC;
	loadDirCmd: in STD_LOGIC;
	loadEnaCmd: in STD_LOGIC;
	pwmout: out STD_LOGIC;
	dirout: out STD_LOGIC;
	enaout: out STD_LOGIC
	);
end pwmgen;

architecture behavioral of pwmgen is

signal pwmval: STD_LOGIC_VECTOR (7 downto 0);
signal dir: STD_LOGIC;
signal ena: STD_LOGIC;
signal pwm: STD_LOGIC;


begin
	apwmgen: process  (clk, 
	 						refcount,
							ibus,
							loadpwmval,
							loadDirCmd,
							pwmval,
							dir, 
						 	pwm
							)
							
	begin
		if clk'event and clk = '1' then
			dirout <= dir;			
			enaout <= not ena;
			if (UNSIGNED(refcount) < UNSIGNED(pwmval)) then 
				pwm <= '1'; 
			else 
				pwm <= '0';
			end if;
			pwmout <= pwm;
			if (loadpwmval = '1') then 
 		   	pwmval <= ibus(15 downto 8);
			end if;	
			if (loadDirCmd = '1') then 	   	
				dir <= ibus(15);
			end if;	
			if (loadEnaCmd = '1') then 	   	
				ena <= ibus(0);
			end if;	
		end if;
	end process;
end behavioral;

