library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity pwmref is
    Port (
	 		clk: in STD_LOGIC;
			refcount: out STD_LOGIC_VECTOR (7 downto 0);
			samplegen: out STD_LOGIC;
			ibus: in STD_LOGIC_VECTOR (7 downto 0);
			sampledivload: in STD_LOGIC;
			clearsampleff: in STD_LOGIC
			);
end pwmref;

architecture behavioral of pwmref is

signal count: STD_LOGIC_VECTOR (7 downto 0);
signal sampledivisor: STD_LOGIC_VECTOR (7 downto 0);
signal samplecounter: STD_LOGIC_VECTOR (3 downto 0);
signal prescale: STD_LOGIC_VECTOR(3 downto 0);
signal sampleff: STD_LOGIC;
signal countedge1: STD_LOGIC;
signal countedge2: STD_LOGIC;
begin
	apwmref: process  (clk,
							sampledivload,
							count,
							samplecounter,
							sampledivisor,
							prescale,
							ibus
							)
	begin
		if clk'event and clk = '1' then
			countedge2 <= countedge1;
			if clearsampleff = '1' then
				sampleff <= '0';
			end if;
			if countedge1 = '0' and countedge2 = '1' then
				sampleff <= '1';
			end if;
			prescale <= prescale -1;
			if prescale = 1 then
				prescale <= sampledivisor(7 downto 4);			
				count <= count + 1;			
				if count = 0 then
					samplecounter <= samplecounter -1;
					if samplecounter = 1 then	
						countedge1 <= '1';
						samplecounter <= sampledivisor(3 downto 0);
					else
						countedge1 <= '0';
					end if;
				end if;			
			end if;
			if sampledivload = '1' then
 		   	sampledivisor <= ibus;
				samplecounter <= sampledivisor(3 downto 0);
				prescale <= sampledivisor(7 downto 4);
			end if;	
		end if;
	end process;
	refcount <= count;
	samplegen <= sampleff;
end behavioral;

