library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity pwmref is
    Port (
	 		clk: in STD_LOGIC;
			refcount: out STD_LOGIC_VECTOR (10 downto 0);
			irqgen: out STD_LOGIC;
			ibus: in STD_LOGIC_VECTOR (15 downto 0);
			obus: out STD_LOGIC_VECTOR (15 downto 0);
			irqdivload: in STD_LOGIC;
			irqdivread: in STD_LOGIC
			);
end pwmref;

architecture behavioral of pwmref is

signal count: STD_LOGIC_VECTOR (10 downto 0);
signal irqdivisor: STD_LOGIC_VECTOR (7 downto 0);
signal irqcounter: STD_LOGIC_VECTOR (7 downto 0);
signal irqdivload1: STD_LOGIC;
signal irqdivload2: STD_LOGIC;

begin
	apwmref: process  (clk,
							irqdivload,irqdivload1,irqdivload2,
							count,
							irqcounter,
							irqdivisor,
							ibus,
							irqdivread) 
	begin
		if clk'event and clk = '1' then
			count <= count + 1;			
			irqdivload1 <= irqdivload;
			irqdivload2 <= irqdivload1;
			if count = 0 then
				irqcounter <= irqcounter -1;
				if irqcounter = 0 then	
					irqgen <= '1'; 
					irqcounter <= irqdivisor;
				else 
					irqgen <= '0';
				end if;
			end if;			
			if (irqdivload1 = '0') and (irqdivload2 = '1') then
 		   	irqdivisor <= ibus(7 downto 0);
				irqcounter <= irqdivisor;
			end if;	
		end if;
		if irqdivread = '1' then
			obus(7 downto 0) <= irqdivisor;
		else
			obus <= "ZZZZZZZZZZZZZZZZ";
		end if;
	end process;
	refcount <= count;
end behavioral;

