;PID.ASM
;todo
; output all pwm's after the pid loop runs

;2axis 30usec software multiply
;4axis 15usec hardware multiply

;****************************** PID  ***********************************
pid	getq	encposq,rbq	;dest-enc
	putq	rbq,mirrorencq	;save for readback

	gets	pidonq,raq
	OR	raq,raq
	ifnz
P		getq	desposx+2,raq
		subq	rbq,raq		;error
		putq	raq,ierrorq	;save for I

;log max positive error
		getq	maxposerrq,rbq
		subq	raq,rbq
		msb2carry rbq+3		;check for negative
		ifc
			putq	raq,maxposerrq
		endif		

;log max negative error
		getq	maxnegerrq,rbq
		subq	raq,rbq		;subtract larger from smaller
		msb2carry rbq+3		;check for positive
		ifnc
			putq	raq,maxnegerrq
		endif		

;check for excessive position error
		absq	raq
		getq	exerrorq,rbq
		subq	raq,rbq		;rbq = rbq - raq
		ifc	;error
			clrs	rbq
			puts	rbq,pidonq	;turn pid off
			puts	rbq,pwm		;turn off pwm
			puts	rbq,moveq	;turn off moving
			loads	255,rbq
			puts	rbq,exerrorfq	;indicate fault
		else ;ok
			clrq	rcq		;clear result
			getq	ierrorq,raq	;get it back
			getd	kpd,rbq		;set gain
			call	mul
			addq	rbq,rcq


I			getd	ierrorq,raq
			getd	kid,rbq
			call	mul		;rbq scaled error

			getq	integralq,raq
			addq	raq,rbq
;bound rbq
			msb2carry	rbq+3
			ifc	;neg
				getq	kilq,raq
				addq	rbq,raq
				msb2carry	raq+3
				ifc
					getq	kilq,raq
					negq	raq
					movq	raq,rbq	;limit
				endif				
			else	;both positive
				getq	kilq,raq
				subq	rbq,raq
				msb2carry	raq+3
				ifc
					getq	kilq,raq
					movq	raq,rbq	;limit
				endif				
			endif

			putq	rbq,integralq	;save for next time
;bounded we hope
			addq	rbq+0,rcq		;works but too fast
;			saddtq	rbq+1,rcq		;broken ???

D			gets	ddivq,tempt		;scale
			decs	tempt	
			ifc	;done
				gets	hostddivq,tempt	;reload
				getq	mirrorencq,rbq	;despos
				getq	lastposq,raq
				subq	rbq,raq		;cur-last
				putq	raq,derrorq	;save delta

				getq	mirrorencq,raq	;save last position
				putq	raq,lastposq
			endif

			puts	tempt,ddivq
			getd	derrorq,raq
			getd	kdd,rbq		;get d term
			call	mul		;raq*rbq
			addq	rbq,rcq

PWM			nots	rcq+3
			puts	rcq+3,dir		;direction
			nots	rcq+3

			absq	rcq
			OR	rcq+2,rcq+3
			ifnz
				loads	255,rcq+1	;bound
			endif

			puts	rcq+1,pwm		;pwm
		endif ;error
	endif	;pid on

	nexttask task3

;***************************** SUBROUTINES ************************************
mul	shmuldq	raq,rbq
	ret


;************************ REVSIONS ********************************************

;added excessive position error
;added pidon
;changed encposq to mirrorencq in D
;removed idiv 
